﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Media.Effects;

namespace PerlinNoiseShader.ImprovedNoise2D
{
    public class PrepNoise2DEffect:ShaderEffect
    {
        public enum Prep { GRAD, GRAD1, GRAD2 };
        public static readonly DependencyProperty permProperty = ShaderEffect.RegisterPixelShaderSamplerProperty("perm", typeof(PrepNoise2DEffect), 0);
        public static readonly DependencyProperty gradProperty = ShaderEffect.RegisterPixelShaderSamplerProperty("grad", typeof(PrepNoise2DEffect), 1);
        
        public PrepNoise2DEffect(Prep ePrep)
        {
            Uri u;
            switch (ePrep)
            {
                case Prep.GRAD:
                    {
                        u = new Uri(@"/PerlinNoiseShader;component/ImprovedNoise2D/gradShader.ps", UriKind.Relative);             
                        break;
                    }
                case Prep.GRAD1:
                    {
                        u = new Uri(@"/PerlinNoiseShader;component/ImprovedNoise2D/grad1Shader.ps", UriKind.Relative);
                        break;
                    }
                default:
                    {
                        u = new Uri(@"/PerlinNoiseShader;component/ImprovedNoise2D/grad2Shader.ps", UriKind.Relative);
                        break;
                    }
            }
            PixelShader = new PixelShader() { UriSource = u };
            UpdateShaderValue(permProperty);
            UpdateShaderValue(gradProperty);
        }
        
        public Brush perm
        {
            get { return (Brush)GetValue(permProperty); }
            set { SetValue(permProperty, value); }
        }

        public Brush grad
        {
            get { return (Brush)GetValue(gradProperty); }
            set { SetValue(gradProperty, value); }
        }
    
    }
}
