﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Media.Imaging;
using PerlinNoiseShader.PerlinNoise2D;
using PerlinNoiseShader.NoiseBlender;
using PerlinNoiseShader.Simplex2D;
using PerlinNoiseShader.ImprovedNoise;
using PerlinNoiseShader.DisplacementMapFilter;
using PerlinNoiseShader.ColorMap;
using PerlinNoiseShader.ImprovedNoise2D;
using System.Windows.Media.Effects;
using PerlinNoiseShader.RadialMapper;


namespace PerlinNoiseShader
{
    public partial class Page : UserControl
    {
        #region variables
        private WriteableBitmap oDisplacementBitmap1, coronaBitmap, drawBitmap;
        private WriteableBitmap[] aWriteableBitmap = new WriteableBitmap[5];
        private WriteableBitmap initBitmap = new WriteableBitmap(912 / 4, (int)(30));
        private WriteableBitmap paletteBitmap = new WriteableBitmap(912 / 4, 30);
        private WriteableBitmap stretchedBitmap = new WriteableBitmap(912 / 2, 60);
        private NoiseBlenderClass oNoiseBlenderClass = new NoiseBlenderClass();
        ImprovedNoiseClass oImprovedNoiseClass;
        Rectangle oDisplacementRectangle1, drawRectangle;
        Ellipse oEllipse = new Ellipse();
        const int octaves1 = 4;
        const int octaves2 = 4;
        float[] aZ1 = new float[octaves1];
        float[] aZ2 = new float[octaves2];
        Size[] aCoronaOffset = new Size[octaves2];
        float z1 = 0.04f;
        float z2 = 0.02f;
        Size[] aCloudsOffset = new Size[octaves1];
        Size freqXY1 = new Size(0.0195, 0.0195);
        Size freqXY2 = new Size(8*0.0195, 8*0.0195);
        ImageBrush xBrush, yBrush, zBrush;
        Ellipse oMidEllipse = new Ellipse();
        List<int> colorList = new List<int>();
        float coreZ = 0, coreX=0;
        List<Ellipse> oEllipseList = new List<Ellipse>();
        Random oRandom = new Random();
        Size[] aFireOffset1 = new Size[3];
        Rectangle drawRectangle1 = new Rectangle(), smokeRectangle1 = new Rectangle(), coronaRectangle=new Rectangle();
        WriteableBitmap noiseBitmap1 = new WriteableBitmap(300, 300), smokeBitmap1 = new WriteableBitmap(300, 200);
        Size[] aFireOffset2 = new Size[3];
        Rectangle drawRectangle2 = new Rectangle(), smokeRectangle2 = new Rectangle();
        Rectangle displacementRectangle = new Rectangle(), noiseRectangle = new Rectangle();
        WriteableBitmap noiseBitmap2 = new WriteableBitmap(300, 300), smokeBitmap2 = new WriteableBitmap(300, 200);
        Noise2D oNoise2D = new Noise2D(100);
        private bool pause = false;
        int currentSelected = 0, b4selected=0;
        TranslateTransform oTranslateTransform = new TranslateTransform();
        WriteableBitmap areaMap, backgroundMap, colorMap, currentMap;
        int posX = 0, posY = 0, deltaX = 3, deltaY = 2, diameter = 0;
        TranslateTransform lensTranslate = new TranslateTransform();
        Ellipse drawEllipse = new Ellipse();
        Rectangle paletteRectangle = new Rectangle();
        int paletteIndex = 0;
        bool isPlasmaClicked = false;
        #endregion

        public Page()
        {
            // Required to initialize variables
            InitializeComponent();
            Application.Current.Host.Settings.MaxFrameRate = 20;
            Application.Current.Host.Settings.EnableFrameRateCounter = true;
            
            CompositionTarget.Rendering += new EventHandler(CompositionTarget_Rendering);
            

        }

        private void initCloud()
        {
            //flat improved 3D noise which displaces a gradient
            int width = 150;
            int height = 150;
            aWriteableBitmap[0] = new WriteableBitmap(width, height);
            oImprovedNoiseClass = new ImprovedNoiseClass(100);
            oDisplacementBitmap1 = new WriteableBitmap(width, height);
            oNoiseBlenderClass = new NoiseBlenderClass();
            for (int i = 0; i < octaves1; i++) aZ1[i] = 0;
            oNoiseBlenderClass.improvedTurbulence(freqXY1, octaves1, 100, null, aZ1, 1, 0.5f, true, Color.FromArgb(255, 0, 255, 255), Color.FromArgb(255, 255, 255, 255), oDisplacementBitmap1);
            Rectangle oRectangle = new Rectangle();
            oRectangle.Width = width;
            oRectangle.Height = 1;
            LinearGradientBrush oLinearGradientBrush = new LinearGradientBrush();
            oLinearGradientBrush.StartPoint = new Point(0.2, 0);
            oLinearGradientBrush.EndPoint = new Point(1, 0);
            GradientStopCollection oGradientStopCollection = new GradientStopCollection();
            GradientStop oGradientStop = new GradientStop();
            oGradientStop.Color = Color.FromArgb(255, 30, 30, 255);
            oGradientStop.Offset = 0;
            oGradientStopCollection.Add(oGradientStop);
            oGradientStop = new GradientStop();
            oGradientStop.Color = Color.FromArgb(255, 240, 240, 255);
            oGradientStop.Offset = 1;
            oGradientStopCollection.Add(oGradientStop);
            oLinearGradientBrush.GradientStops = oGradientStopCollection;
            oRectangle.Fill = oLinearGradientBrush;
            WriteableBitmap oSourceBitmap = new WriteableBitmap(width, 1);
            oSourceBitmap.Render(oRectangle, null);
            oSourceBitmap.Invalidate();
            YDisplacementMapEffect oYDisplacementMapEffect = new YDisplacementMapEffect(true);
            oYDisplacementMapEffect.scale = 0.18f;
            oYDisplacementMapEffect.sourceImage = oSourceBitmap;
            oYDisplacementMapEffect.displacementImage = oDisplacementBitmap1;
            oDisplacementRectangle1 = new Rectangle();
            oDisplacementRectangle1.Effect = oYDisplacementMapEffect;
            oDisplacementRectangle1.Width = width;
            oDisplacementRectangle1.Height = height;
            oDisplacementRectangle1.Fill = new SolidColorBrush(Color.FromArgb(255, 255, 255, 255));
            aWriteableBitmap[0].Render(oDisplacementRectangle1, null);
            aWriteableBitmap[0].Invalidate();
            myImage1.Source = aWriteableBitmap[0];
        }

        private int convertDoubleToInt(double number)
        {
            int r = (int)number;
            number = (number - r) * 256;
            int g = (int)number;
            number = (number - g) * 256;
            int b = (int)number;
            number = (number - b) * 256;
            int a = (int)number;
            return (a << 24) | (r << 16) | (g << 8) | b;
        }

        void initCorona()
        {
            //creates flat improved 3D noise which tiles at the x axis and maps the result to a ring
            Rectangle paletteRectangle = new Rectangle();
            paletteRectangle.Width = 256;
            paletteRectangle.Height = 1;
            LinearGradientBrush paletteBrush = new LinearGradientBrush();
            paletteBrush.StartPoint = new Point(0.2, 0);
            paletteBrush.EndPoint = new Point(1, 0);
            GradientStop oGradientStop = new GradientStop();
            oGradientStop.Offset = 0;
            oGradientStop.Color = Color.FromArgb(255, 255, 255, 0);
            paletteBrush.GradientStops.Add(oGradientStop);
            oGradientStop = new GradientStop();
            oGradientStop.Offset = 0.7;
            oGradientStop.Color = Color.FromArgb(255, 255, 128, 0);
            paletteBrush.GradientStops.Add(oGradientStop);
            oGradientStop = new GradientStop();
            oGradientStop.Offset = 1;
            oGradientStop.Color = Color.FromArgb(255, 255, 255, 255);
            paletteBrush.GradientStops.Add(oGradientStop);
            paletteRectangle.Fill = paletteBrush;
            WriteableBitmap oSourceBitmap = new WriteableBitmap(paletteRectangle,null);
            for(int i=0;i<octaves2;i++) aCoronaOffset[i] = new Size(0,0);
            oNoiseBlenderClass.improvedTurbulence(new Size(32.0 / (912.0 / 4), 0.065), new iSize(32, 256), octaves2, 100, aCoronaOffset, aZ2, 1, 0.5f, false, Color.FromArgb(255, 0, 0, 0), Color.FromArgb(255, 255, 0, 0), initBitmap);
            displacementRectangle.Width = 912 / 4;
            displacementRectangle.Height = 30;
            displacementRectangle.Fill = new SolidColorBrush(Color.FromArgb(255, 255, 0, 0));
            YDisplacementMapEffect oYDisplacementMapEffect = new YDisplacementMapEffect(true);
            oYDisplacementMapEffect.displacementImage = initBitmap;
            oYDisplacementMapEffect.sourceImage = oSourceBitmap;
            oYDisplacementMapEffect.scale = 0.47f;
            displacementRectangle.Effect = oYDisplacementMapEffect;
            //palette
            paletteBitmap.Render(displacementRectangle, null);
            paletteBitmap.Invalidate();
            noiseRectangle.Width = 912 / 2;
            noiseRectangle.Height = 60;
            ImageBrush noiseBrush = new ImageBrush();
            noiseBrush.ImageSource = paletteBitmap;
            noiseRectangle.Fill = noiseBrush;
            noiseRectangle.Stretch = Stretch.Fill;
            //stretch
            stretchedBitmap.Render(noiseRectangle, null);
            stretchedBitmap.Invalidate();
            oEllipse.Width = 150;
            oEllipse.Height = 150;
            oEllipse.Fill = new SolidColorBrush(Color.FromArgb(255, 255, 0, 0));
            GeometryGroup oGeometryGroup = new GeometryGroup();
            GeometryCollection oGeometryCollection = new GeometryCollection();
            ImageBrush testBrush = new ImageBrush();
            
            oGeometryGroup.FillRule = FillRule.EvenOdd;

            EllipseGeometry oEllipseGeometry = new EllipseGeometry();
            oEllipseGeometry.Center = new Point(74, 74);
            oEllipseGeometry.RadiusX = 72;
            oEllipseGeometry.RadiusY = 72;
            oGeometryCollection.Add(oEllipseGeometry);
            oEllipseGeometry = new EllipseGeometry();
            oEllipseGeometry.Center = new Point(74, 74);//74
            oEllipseGeometry.RadiusX = 42;
            oEllipseGeometry.RadiusY = 42;
            oGeometryCollection.Add(oEllipseGeometry);
            oGeometryGroup.Children = oGeometryCollection;
            oEllipse.Clip = oGeometryGroup;
            //radial mapping
            RadialMapperEffect oRadialMapperEffect = new RadialMapperEffect();
            float scale = 145f/63f;
            oRadialMapperEffect.sourceImage = stretchedBitmap;//initBitmap;
            oRadialMapperEffect.addLength = -84.0f / 300.0f*scale*2f;
            oRadialMapperEffect.scale = scale;//150f / 108f;
            oEllipse.Effect = oRadialMapperEffect;
            aWriteableBitmap[1] = new WriteableBitmap(300, 300);
            coronaBitmap = new WriteableBitmap(150, 150);
            myImage2.Source = aWriteableBitmap[1];
            coronaBitmap.Render(oEllipse, null);
            coronaBitmap.Invalidate();
            //stretch
            ImageBrush coronaBrush = new ImageBrush();
            coronaBrush.ImageSource = coronaBitmap;
            coronaRectangle.Width = 300;
            coronaRectangle.Height = 300;
            coronaRectangle.Stretch = Stretch.Fill;
            coronaRectangle.Fill = coronaBrush;
            aWriteableBitmap[1].Render(coronaRectangle, null);
            aWriteableBitmap[1].Invalidate();
             
        }

        private void initMid()
        {
            //creates the center of the sun
            oImprovedNoiseClass = new ImprovedNoiseClass(100);
            double radius = 89;
            int diameter = (int)radius * 2;
            oMidEllipse.Width = 178;
            oMidEllipse.Height = 178;
            oMidEllipse.Fill = new SolidColorBrush(Color.FromArgb(255, 255, 0, 0));
            EllipseGeometry oMidEllipseGeometry = new EllipseGeometry();
            oMidEllipseGeometry.Center = new Point(89, 89);
            oMidEllipseGeometry.RadiusX = radius;
            oMidEllipseGeometry.RadiusY = radius;
            oMidEllipse.Clip = oMidEllipseGeometry;
            int index=0;
            WriteableBitmap xPlane = new WriteableBitmap(178, 178);
            WriteableBitmap yPlane = new WriteableBitmap(178, 178);
            WriteableBitmap zPlane = new WriteableBitmap(178, 178);
            //set x and y values to look like a sphere
            for (int y = 0; y < 178; ++y)
            {
                double yr = y / 178.0; 
                double lat = Math.Asin(1 - yr * 2); 
                double yd = 0.5 - lat / Math.PI - yr; 
                double yc = (yd * 178+y) * 0.256 + 80;
                double ew = Math.Cos(lat); 
                for (var x = 0; x < 178; ++x)
                {
                    double xr = x / 178.0;
                    double lap = Math.Acos((0.5 - xr) / ew * 2);
                    double xc = 0;
                    if (lap == Double.NaN)
                    {
                        xc = xr > 0.5 ? 0xFF : 0;
                    }
                    else
                    {
                        double xd = lap / Math.PI - xr;
                        xc = (xd * 178+x) * 0.256 + 80;
                    }
                    xPlane.Pixels[index] = convertDoubleToInt(xc);
                    yPlane.Pixels[index] = convertDoubleToInt(yc);
                    zPlane.Pixels[index] = convertDoubleToInt(0);
                    index++;
               }
            }
            xPlane.Invalidate();
            yPlane.Invalidate();
            zPlane.Invalidate();
            xBrush = new ImageBrush();
            xBrush.ImageSource = xPlane;
            yBrush = new ImageBrush();
            yBrush.ImageSource = yPlane;
            zBrush = new ImageBrush();
            zBrush.ImageSource = zPlane;

            drawBitmap = new WriteableBitmap(178, 178);
            oImprovedNoiseClass.customUIElement = oMidEllipse;
            oImprovedNoiseClass.singleNoise(xBrush, yBrush, zBrush, new Vector3d(2500, 2500, 2500), 1, false, Color.FromArgb(255, 255, 171, 0), Color.FromArgb(255, 255, 255, 0), drawBitmap);
            drawRectangle = new Rectangle();
            drawRectangle.Width = 178;
            drawRectangle.Height = 178;
            ImageBrush drawBrush = new ImageBrush();
            drawBrush.ImageSource = drawBitmap;
            drawBrush.Stretch = Stretch.None;
            drawRectangle.Fill = drawBrush;
            oTranslateTransform.X = 60;
            oTranslateTransform.Y = 60;
            aWriteableBitmap[1].Render(drawRectangle, oTranslateTransform);
            aWriteableBitmap[1].Invalidate();
        }

        private void initFire1()
        {
            //the fire is created by the perlin noise displacement of a gradient
            //the smoke is perlin noise with smoke colors and without displacement and be added to the fire
            aWriteableBitmap[2] = new WriteableBitmap(300, 300);
            aFireOffset1 = new Size[3];
            aFireOffset1[0] = new Size(50, 50);
            aFireOffset1[1] = new Size(50, 50);
            aFireOffset1[2] = new Size(50, 50);

            oNoiseBlenderClass.turbulence2D(new Size(0.0865, 0.0165), 3, 100, aFireOffset1, 1.0f, 0.5f, false, Color.FromArgb(255, 0, 0, 0), Color.FromArgb(255, 255, 255, 255), noiseBitmap1);
            Rectangle flameRectangle = new Rectangle();
            flameRectangle.Width = 300;
            flameRectangle.Height = 1;
            LinearGradientBrush paletteBrush = new LinearGradientBrush();
            paletteBrush.StartPoint = new Point(0.3, 0);
            paletteBrush.EndPoint = new Point(1, 0);
            GradientStop oGradientStop = new GradientStop();
            oGradientStop.Offset = 1;
            oGradientStop.Color = Color.FromArgb(255, 255, 255, 255);
            paletteBrush.GradientStops.Add(oGradientStop);
            oGradientStop = new GradientStop();
            oGradientStop.Offset = 0.5;
            oGradientStop.Color = Color.FromArgb(255, 255, 255, 0);
            paletteBrush.GradientStops.Add(oGradientStop);
            oGradientStop = new GradientStop();
            oGradientStop.Offset = 0.2;
            oGradientStop.Color = Color.FromArgb(255, 255, 127, 0);
            paletteBrush.GradientStops.Add(oGradientStop);
            oGradientStop = new GradientStop();
            oGradientStop.Offset = 0.1;
            oGradientStop.Color = Color.FromArgb(255, 255, 50, 0);
            paletteBrush.GradientStops.Add(oGradientStop);
            oGradientStop = new GradientStop();
            oGradientStop.Offset = 0.05;
            oGradientStop.Color = Color.FromArgb(255, 255, 127, 0);
            paletteBrush.GradientStops.Add(oGradientStop);
            oGradientStop = new GradientStop();
            oGradientStop.Offset = 0.0;
            oGradientStop.Color = Color.FromArgb(0, 255, 127, 0);
            paletteBrush.GradientStops.Add(oGradientStop);
            flameRectangle.Fill = paletteBrush;
            WriteableBitmap paletteBitmap = new WriteableBitmap(300, 1);
            paletteBitmap.Render(flameRectangle, null);
            paletteBitmap.Invalidate();
            YDisplacementMapEffect oYDisplacementMapEffect = new YDisplacementMapEffect(false);
            oYDisplacementMapEffect.displacementImage = noiseBitmap1;
            oYDisplacementMapEffect.sourceImage = paletteBitmap;
            oYDisplacementMapEffect.scale = 0.5f;
            drawRectangle1.Width = 300;
            drawRectangle1.Height = 300;
            drawRectangle1.Fill = new SolidColorBrush(Color.FromArgb(255, 255, 255, 255));
            drawRectangle1.Effect = oYDisplacementMapEffect;
            Array.Copy(noiseBitmap1.Pixels, aWriteableBitmap[2].Pixels, 300 * 200);
            aWriteableBitmap[2].Render(drawRectangle1, null);
            aWriteableBitmap[2].Invalidate();
            myImage3.Source = aWriteableBitmap[2];
            smokeRectangle1.Width = 300;
            smokeRectangle1.Height = 200;
            Array.Copy(noiseBitmap1.Pixels, smokeBitmap1.Pixels, 300 * 200);
            smokeRectangle1.Fill = new SolidColorBrush(Color.FromArgb(255, 255, 255, 255));
            WriteableBitmap smokePaletteBitmap = new WriteableBitmap(256, 1);
            Rectangle smokePaletteRectangle = new Rectangle();
            smokePaletteRectangle.Width = 256;
            smokePaletteRectangle.Height = 1;
            paletteBrush = new LinearGradientBrush();
            paletteBrush.StartPoint = new Point(0, 0);
            paletteBrush.EndPoint = new Point(1, 0);
            oGradientStop = new GradientStop();
            oGradientStop.Offset = 1;
            oGradientStop.Color = Color.FromArgb(100, 100, 50, 20);
            paletteBrush.GradientStops.Add(oGradientStop);
            oGradientStop = new GradientStop();
            oGradientStop.Offset = 0;
            oGradientStop.Color = Color.FromArgb(0, 255, 255, 255);
            paletteBrush.GradientStops.Add(oGradientStop);
            smokePaletteRectangle.Fill = paletteBrush;
            smokePaletteBitmap.Render(smokePaletteRectangle, null);
            smokePaletteBitmap.Invalidate();
            ColorMapEffect oColorMapEffect = new ColorMapEffect();
            oColorMapEffect.sourceImage = smokeBitmap1;
            oColorMapEffect.aColorBitmap = new WriteableBitmap[] { smokePaletteBitmap };
            smokeRectangle1.Effect = oColorMapEffect;
        }

        private void initFire2()
        {
            //the fire is created by the perlin noise displacement of a gradient
            //the smoke is perlin noise with smoke colors and without displacement and be added to the fire
            //fire 2 uses |noise| and not noise like in fire 1 and uses other perlin noise parameters, else there is no difference to fire 1
            aWriteableBitmap[3] = new WriteableBitmap(300, 300);
            aFireOffset2 = new Size[3];
            aFireOffset2[0] = new Size(50, 50);
            aFireOffset2[1] = new Size(50, 50);
            aFireOffset2[2] = new Size(50, 50);

            oNoiseBlenderClass.turbulence2D(new Size(0.0165, 0.0165), 3, 100, aFireOffset2, 1.0f, 0.5f, true, Color.FromArgb(255, 0, 0, 0), Color.FromArgb(255, 255, 255, 255), noiseBitmap2);
            Rectangle flameRectangle = new Rectangle();
            flameRectangle.Width = 300;
            flameRectangle.Height = 1;
            LinearGradientBrush paletteBrush = new LinearGradientBrush();
            paletteBrush.StartPoint = new Point(0.2, 0);
            paletteBrush.EndPoint = new Point(1, 0);
            GradientStop oGradientStop = new GradientStop();
            oGradientStop.Offset = 1;
            oGradientStop.Color = Color.FromArgb(255, 255, 255, 255);
            paletteBrush.GradientStops.Add(oGradientStop);
            oGradientStop = new GradientStop();
            oGradientStop.Offset = 0.5;
            oGradientStop.Color = Color.FromArgb(255, 255, 255, 0);
            paletteBrush.GradientStops.Add(oGradientStop);
            oGradientStop = new GradientStop();
            oGradientStop.Offset = 0.2;
            oGradientStop.Color = Color.FromArgb(255, 255, 127, 0);
            paletteBrush.GradientStops.Add(oGradientStop);
            oGradientStop = new GradientStop();
            oGradientStop.Offset = 0.1;
            oGradientStop.Color = Color.FromArgb(255, 255, 50, 0);
            paletteBrush.GradientStops.Add(oGradientStop);
            oGradientStop = new GradientStop();
            oGradientStop.Offset = 0.05;
            oGradientStop.Color = Color.FromArgb(255, 255, 127, 0);
            paletteBrush.GradientStops.Add(oGradientStop);
            oGradientStop = new GradientStop();
            oGradientStop.Offset = 0.0;
            oGradientStop.Color = Color.FromArgb(0, 255, 127, 0);
            paletteBrush.GradientStops.Add(oGradientStop);
            flameRectangle.Fill = paletteBrush;
            WriteableBitmap paletteBitmap = new WriteableBitmap(300, 1);
            paletteBitmap.Render(flameRectangle, null);
            paletteBitmap.Invalidate();
            YDisplacementMapEffect oYDisplacementMapEffect = new YDisplacementMapEffect(false);
            oYDisplacementMapEffect.displacementImage = noiseBitmap2;
            oYDisplacementMapEffect.sourceImage = paletteBitmap;
            oYDisplacementMapEffect.scale = 0.5f;
            drawRectangle2.Width = 300;
            drawRectangle2.Height = 300;
            drawRectangle2.Fill = new SolidColorBrush(Color.FromArgb(255, 255, 255, 255));
            drawRectangle2.Effect = oYDisplacementMapEffect;
            Array.Copy(noiseBitmap2.Pixels, aWriteableBitmap[3].Pixels, 300 * 200);
            aWriteableBitmap[3].Render(drawRectangle1, null);
            aWriteableBitmap[3].Invalidate();
            myImage4.Source = aWriteableBitmap[3];
            smokeRectangle2.Width = 300;
            smokeRectangle2.Height = 200;
            Array.Copy(noiseBitmap2.Pixels, smokeBitmap2.Pixels, 300 * 200);
            smokeRectangle2.Fill = new SolidColorBrush(Color.FromArgb(255, 255, 255, 255));
            WriteableBitmap smokePaletteBitmap = new WriteableBitmap(256, 1);
            Rectangle smokePaletteRectangle = new Rectangle();
            smokePaletteRectangle.Width = 256;
            smokePaletteRectangle.Height = 1;
            paletteBrush = new LinearGradientBrush();
            paletteBrush.StartPoint = new Point(0, 0);
            paletteBrush.EndPoint = new Point(1, 0);
            oGradientStop = new GradientStop();
            oGradientStop.Offset = 1;
            oGradientStop.Color = Color.FromArgb(100, 100, 50, 20);
            paletteBrush.GradientStops.Add(oGradientStop);
            oGradientStop = new GradientStop();
            oGradientStop.Offset = 0;
            oGradientStop.Color = Color.FromArgb(0, 255, 255, 255);
            paletteBrush.GradientStops.Add(oGradientStop);
            smokePaletteRectangle.Fill = paletteBrush;
            smokePaletteBitmap.Render(smokePaletteRectangle, null);
            smokePaletteBitmap.Invalidate();
            ColorMapEffect oColorMapEffect = new ColorMapEffect();
            oColorMapEffect.sourceImage = smokeBitmap2;
            oColorMapEffect.aColorBitmap = new WriteableBitmap[] { smokePaletteBitmap };
            smokeRectangle2.Effect = oColorMapEffect;
        }

        private void getCurrentPalette(WriteableBitmap palette, WriteableBitmap block, int index)
        {
            if (index < 0 || index >= palette.Pixels.Length) return;
            if (index + 255 < palette.Pixels.Length)
            {
                Buffer.BlockCopy(palette.Pixels, index * 4, block.Pixels, 0, 256 * 4);
            }
            else
            {
                int difference=palette.Pixels.Length-index;
                Buffer.BlockCopy(palette.Pixels, index * 4, block.Pixels, 0, difference * 4);
                Buffer.BlockCopy(palette.Pixels, 0, block.Pixels, (index+difference)*4, (256 - difference) * 4);
            }
        }

        private void initPlasma()
        {
            //perlin noise and old school palette rotation and bitmap displacment to simulate a lens
            aWriteableBitmap[4] = new WriteableBitmap(300, 300);
            backgroundMap = new WriteableBitmap(300, 300);
            Rectangle mapRectangle = new Rectangle();
            mapRectangle.Width = 1024;
            mapRectangle.Height = 1;
            LinearGradientBrush paletteBrush = new LinearGradientBrush();
            paletteBrush.StartPoint = new Point(0, 0);
            paletteBrush.EndPoint = new Point(1, 0);
            GradientStop oGradientStop = new GradientStop();
            oGradientStop.Offset = 0;
            oGradientStop.Color = Color.FromArgb(255, 255, 0, 0);
            paletteBrush.GradientStops.Add(oGradientStop);
            oGradientStop = new GradientStop();
            oGradientStop.Offset = 0.25;
            oGradientStop.Color = Color.FromArgb(255, 255, 255, 255);
            paletteBrush.GradientStops.Add(oGradientStop);
            oGradientStop = new GradientStop();
            oGradientStop.Offset = 0.5;
            oGradientStop.Color = Color.FromArgb(255, 0, 0, 255);
            paletteBrush.GradientStops.Add(oGradientStop);
            oGradientStop = new GradientStop();
            oGradientStop.Offset = 0.625;
            oGradientStop.Color = Color.FromArgb(255, 0, 255, 0);
            paletteBrush.GradientStops.Add(oGradientStop);
            oGradientStop = new GradientStop();
            oGradientStop.Offset = 0.75;
            oGradientStop.Color = Color.FromArgb(255, 255, 255, 0);
            paletteBrush.GradientStops.Add(oGradientStop);
            oGradientStop = new GradientStop();
            oGradientStop.Offset = 0.8;
            oGradientStop.Color = Color.FromArgb(255, 255, 0, 0);
            paletteBrush.GradientStops.Add(oGradientStop);
            oGradientStop = new GradientStop();
            oGradientStop.Offset = 0.9;
            oGradientStop.Color = Color.FromArgb(255, 255, 0, 255);
            paletteBrush.GradientStops.Add(oGradientStop);
            oGradientStop = new GradientStop();
            oGradientStop.Offset = 1;
            oGradientStop.Color = Color.FromArgb(255, 255, 0, 0);
            paletteBrush.GradientStops.Add(oGradientStop);
            mapRectangle.Fill = paletteBrush;
            colorMap = new WriteableBitmap(mapRectangle,null);
            currentMap = new WriteableBitmap(256, 1);
            if (paletteIndex > 768)
            {
                Buffer.BlockCopy(colorMap.Pixels, paletteIndex * 4, currentMap.Pixels, 0, (1024 - paletteIndex) * 4);
                Buffer.BlockCopy(colorMap.Pixels, 0, currentMap.Pixels, (1024 - paletteIndex) * 4, (256 - (1024 - paletteIndex)) * 4);
            }
            else Buffer.BlockCopy(colorMap.Pixels, paletteIndex * 4, currentMap.Pixels, 0, 256 * 4);
            WriteableBitmap baseMap = new WriteableBitmap(300, 300);
            //offsets to reduce artefacts
            Random oRandom = new Random();
            Size[] aOffset = new Size[7];
            for (int i = 0; i < 7; i++) aOffset[i] = new Size(oRandom.NextDouble(), oRandom.NextDouble());
            int randomSize = 2 + oRandom.Next() % 12;
            oNoiseBlenderClass.turbulence2D(new Size(randomSize / 300.0, randomSize / 300.0), new iSize(randomSize, randomSize), 7, aOffset, 1, 0.5f, false, Color.FromArgb(255, 0, 0, 0), Color.FromArgb(255, 255, 255, 255), baseMap);
            paletteRectangle.Width = 300;
            paletteRectangle.Height = 300;
            paletteRectangle.Fill = new SolidColorBrush(Color.FromArgb(255,255,0,0));
            ColorMapEffect oColorMapEffect = new ColorMapEffect();
            oColorMapEffect.aColorBitmap=new WriteableBitmap[]{currentMap};
            oColorMapEffect.sourceImage = baseMap;
            paletteRectangle.Effect = oColorMapEffect;
            backgroundMap.Render(paletteRectangle, null);
            backgroundMap.Invalidate();
            //oImprovedNoiseClass.singleNoise(0.4546f, new Size(5.0 / 300.0, 5.0 / 300.0), new iSize(5, 5), new Size(), 1, false, Color.FromArgb(255, 255, 0, 0), Color.FromArgb(255, 255, 255, 255), aWriteableBitmap[4]);
            
            double radius = 70;
            diameter= (int)radius * 2;
            double magnify = 2;
            double convexity = 0.7;
            double mRoot = 0.5;
            int index = 0;
            WriteableBitmap sphereMap = new WriteableBitmap(diameter, diameter);
            for (int y = 0; y < diameter; y++)
            {
                double yKreis = (y - radius) / radius;
                for (int x = 0; x < diameter; x++)
                {
                    double xKreis = (x - radius) / radius;
                    double sqrRadius = Math.Pow(xKreis * xKreis + yKreis * yKreis, 1 / mRoot);
                    if (sqrRadius <= 1)
                    {
                        int xColor = (int)Math.Round(radius * xKreis * ((convexity * sqrRadius + 1) / magnify - 1)) + 128;
                        int yColor = (int)Math.Round(radius * yKreis * ((convexity * sqrRadius + 1) / magnify - 1)) + 128;
                        sphereMap.Pixels[index] = 255 << 24 | xColor << 16 | yColor << 8;
                    }
                    else sphereMap.Pixels[index] = 255 << 24 | 128 << 16 | 128 << 8;
                    index++;
                }
            }
            sphereMap.Invalidate();
            areaMap = new WriteableBitmap(diameter, diameter);
            for (int i = 0; i < diameter; i++)
            {
                Buffer.BlockCopy(backgroundMap.Pixels, 300 * (i+posY) * 4+posX*4, areaMap.Pixels, diameter * i * 4, diameter * 4);
            }
            DisplacementMapEffect oDisplacementMapEffect = new DisplacementMapEffect(false);
            oDisplacementMapEffect.displacementImage = sphereMap;
            oDisplacementMapEffect.scaleXY = new Size(1, 1);
            oDisplacementMapEffect.sourceImage = areaMap;
            WriteableBitmap drawBitmap = new WriteableBitmap(diameter, diameter);
            drawEllipse.Fill = new SolidColorBrush(Color.FromArgb(255, 255, 0, 0));
            drawEllipse.Width = diameter;
            drawEllipse.Height = diameter;
            drawEllipse.Effect = oDisplacementMapEffect;
            EllipseGeometry oDrawEllipseGeometry = new EllipseGeometry();
            oDrawEllipseGeometry.Center = new Point(radius, radius);
            oDrawEllipseGeometry.RadiusX = radius;
            oDrawEllipseGeometry.RadiusY = radius;
            drawEllipse.Clip = oDrawEllipseGeometry;
            lensTranslate.X = posX;
            lensTranslate.Y = posY;
            Buffer.BlockCopy(backgroundMap.Pixels, 0, aWriteableBitmap[4].Pixels, 0, 300 * 300 * 4);
            aWriteableBitmap[4].Invalidate();
            aWriteableBitmap[4].Render(drawEllipse, lensTranslate);
            aWriteableBitmap[4].Invalidate();
            myImage5.Source = aWriteableBitmap[4];
            //myImage5.Source = backgroundMap;
        }

        void Page_Loaded(object sender, RoutedEventArgs e)
        {
            initCloud();
            //MessageBox.Show(Math.Floor(-1.23).ToString());
            
        }

        void CompositionTarget_Rendering(object sender, EventArgs e)
        {
            if (!pause)
            {
                switch (currentSelected)
                {
                    case 0://clouds
                        {
                            aCloudsOffset[0].Width += 2;
                            aCloudsOffset[1].Width += 1.5;
                            aCloudsOffset[2].Width += 0.75;
                            aCloudsOffset[1].Height += 1;
                            aCloudsOffset[2].Height += 0.5;
                            aCloudsOffset[3].Height += 0.25;
                            for (int i = 0; i < octaves1; i++)
                            {
                                double pow = Math.Pow(2, i);
                                if (i != 0)
                                {
                                    aZ1[i] = (float)(aZ1[i] + z1 * pow);
                                    if (aZ1[i] > 256) aZ1[i] -= 256;
                                }
                                if (aCloudsOffset[i].Width > 256.0 / (pow * freqXY1.Width)) aCloudsOffset[i].Width -= 256.0 / (pow * freqXY1.Width);
                                if (aCloudsOffset[i].Height > 256.0 / (pow * freqXY1.Height)) aCloudsOffset[i].Height -= 256.0 / (pow * freqXY1.Height);
                            }
                            
                            oNoiseBlenderClass.customUIElement = null;
                            oNoiseBlenderClass.improvedTurbulence(freqXY1, octaves1, 100, aCloudsOffset, aZ1, 1, 0.5f, true, Color.FromArgb(255, 0, 255, 255), Color.FromArgb(255, 255, 255, 255), oDisplacementBitmap1);
                            //stretch
                            aWriteableBitmap[0].Render(oDisplacementRectangle1, null);
                            aWriteableBitmap[0].Invalidate();
                            break;
                        }
                    case 1: //sun
                        {
                            if (aWriteableBitmap[1] == null)
                            {
                                initCorona();
                                initMid();
                            }
                            else
                            {
                                for (int i = 0; i < octaves2; i++)
                                {
                                    double height = aCoronaOffset[i].Height;
                                    height -= 1;//1.5;
                                    if (height < 0) height += 256.0 / 0.065;
                                    aCoronaOffset[i].Height = height;
                                    aZ2[i] = (float)(aZ2[i] + z2 * Math.Pow(2, i));
                                    if (aZ2[i] > 256) aZ2[i] -= 256;
                                }
                                                                
                                oNoiseBlenderClass.improvedTurbulence(new Size(32.0 / (912.0 / 4), 0.065), new iSize(32, 256), octaves2, 100, aCoronaOffset, aZ2, 1, 0.5f, false, Color.FromArgb(255, 0, 0, 0), Color.FromArgb(255, 255, 0, 0), initBitmap);
                                //displacement
                                paletteBitmap.Render(displacementRectangle, null);
                                paletteBitmap.Invalidate();
                                //stretch
                                stretchedBitmap.Render(noiseRectangle, null);
                                stretchedBitmap.Invalidate();
                                //radial mapping
                                Array.Clear(coronaBitmap.Pixels, 0, coronaBitmap.Pixels.Length);
                                coronaBitmap.Render(oEllipse, null);
                                coronaBitmap.Invalidate();
                                //stretch
                                Array.Clear(aWriteableBitmap[1].Pixels, 0, aWriteableBitmap[1].Pixels.Length);
                                aWriteableBitmap[1].Render(coronaRectangle, null);
                                aWriteableBitmap[1].Invalidate();

                                
                                coreZ += 0.04f;
                                coreX += 0.06f;
                                //if (coreZ < -256) coreZ += 256;
                                if (coreZ > 256f) coreZ -= 256f;
                                if (coreX > 256f) coreX -= 256f;
                                Array.Clear(drawBitmap.Pixels, 0, drawBitmap.Pixels.Length);
                                oImprovedNoiseClass.singleNoise(xBrush, yBrush, zBrush, new Vector3d(2500+coreX, 2500, 2500 + coreZ), 1, false, Color.FromArgb(255, 255, 171, 0), Color.FromArgb(255, 255, 255, 0), drawBitmap);
                                aWriteableBitmap[1].Render(drawRectangle, oTranslateTransform);
                                aWriteableBitmap[1].Invalidate();
                            }
                            break;
                              
                        }

                    case 2: //fire 1
                        {
                            if (aWriteableBitmap[2] == null) initFire1();
                            else
                            {
                                aFireOffset1[0].Height += 8 + oRandom.NextDouble() * 2;
                                aFireOffset1[1].Height += 3 + oRandom.NextDouble() * 1;
                                aFireOffset1[2].Height += 1.5 + oRandom.NextDouble() * 0.5;
                                for (int i = 0; i < 3; i++)
                                {
                                    double pow = Math.Pow(2.0, i);
                                    if (aFireOffset1[i].Width > 256.0 / 0.0865 / pow)
                                    {
                                        aFireOffset1[i].Width -= 256.0 / 0.0865 / pow;
                                    }
                                    if (aFireOffset1[i].Height > 256.0 / 0.0165 / pow) aFireOffset1[i].Height -= 256.0 / 0.0165 / pow;
                                }

                                Array.Clear(noiseBitmap1.Pixels, 0, noiseBitmap1.Pixels.Length);
                                Array.Clear(aWriteableBitmap[2].Pixels, 0, aWriteableBitmap[2].Pixels.Length);
                                oNoiseBlenderClass.customUIElement = null;
                                oNoiseBlenderClass.turbulence2D(new Size(0.0865, 0.0165), 3, 100, aFireOffset1, 1f, 0.5f, false, Color.FromArgb(130, 0, 0, 0), Color.FromArgb(130, 255, 255, 255), noiseBitmap1);
                                Array.Copy(noiseBitmap1.Pixels, smokeBitmap1.Pixels, 300 * 200);
                                aWriteableBitmap[2].Render(smokeRectangle1, null);
                                aWriteableBitmap[2].Render(drawRectangle1, null);
                                aWriteableBitmap[2].Invalidate();
                            }
                            break;
                        }
                    case 3: //fire 2
                        {
                            if (aWriteableBitmap[3] == null) initFire2();
                            double temp = aFireOffset2[0].Width + oRandom.NextDouble() * 2 - 1;
                            aFireOffset2[0].Width = temp < 0 ? temp + 256.0 / 0.0165 : temp;
                            temp = aFireOffset2[1].Width + oRandom.NextDouble() * 1 - 0.5;
                            aFireOffset2[1].Width = temp < 0 ? temp + 256.0 / 0.0165 / 2.0 : temp;
                            temp = aFireOffset2[2].Width + oRandom.NextDouble() * 0.5 - 0.25;
                            aFireOffset2[2].Width = temp < 0 ? temp + 256.0 / 0.0165 / 4.0 : temp;

                            aFireOffset2[0].Height += 8 + oRandom.NextDouble() * 2;
                            aFireOffset2[1].Height += 3 + oRandom.NextDouble() * 1;
                            aFireOffset2[2].Height += 1.5 + oRandom.NextDouble() * 0.5;
                            for (int i = 0; i < 3; i++)
                            {
                                double pow = Math.Pow(2.0, i);
                                if (aFireOffset1[i].Width > 256.0 / 0.0165 / pow)
                                {
                                    aFireOffset1[i].Width -= 256.0 / 0.0165 / pow;
                                }
                                if (aFireOffset1[i].Height > 256.0 / 0.0165 / pow) aFireOffset1[i].Height -= 256.0 / 0.0165 / pow;
                            }

                            Array.Clear(noiseBitmap2.Pixels, 0, noiseBitmap2.Pixels.Length);
                            Array.Clear(aWriteableBitmap[3].Pixels, 0, aWriteableBitmap[3].Pixels.Length);
                            oNoiseBlenderClass.customUIElement = null;
                            oNoiseBlenderClass.turbulence2D(new Size(0.0165, 0.0165), 3, 100, aFireOffset2, 1f, 0.5f, true, Color.FromArgb(130, 0, 0, 0), Color.FromArgb(130, 255, 255, 255), noiseBitmap2);
                            Array.Copy(noiseBitmap2.Pixels, smokeBitmap2.Pixels, 300 * 200);
                            aWriteableBitmap[3].Render(smokeRectangle2, null);
                            aWriteableBitmap[3].Render(drawRectangle2, null);
                            aWriteableBitmap[3].Invalidate();
                            break;
                        }
                    case 4: //plasma and lens
                        {
                        if (aWriteableBitmap[4] == null || b4selected!=currentSelected)
                        {
                            initPlasma();
                        }
                        else
                        {
                            paletteIndex += 2;
                            if (paletteIndex > 1023) paletteIndex -= 1024;
                            if (paletteIndex > 768)
                            {
                                Buffer.BlockCopy(colorMap.Pixels, paletteIndex * 4, currentMap.Pixels, 0, (1024 - paletteIndex) * 4);
                                Buffer.BlockCopy(colorMap.Pixels, 0, currentMap.Pixels, (1024 - paletteIndex) * 4, (256 - (1024 - paletteIndex)) * 4);
                            }
                            else Buffer.BlockCopy(colorMap.Pixels, paletteIndex * 4, currentMap.Pixels, 0, 256 * 4);
                            currentMap.Invalidate();
                            backgroundMap.Render(paletteRectangle, null);
                            backgroundMap.Invalidate();
                            Buffer.BlockCopy(colorMap.Pixels, 256 * 4, currentMap.Pixels, 0, 256 * 4);
                            posX+=deltaX;
                            posY+=deltaY;
                            if (posX + deltaX < 0 || posX + diameter + deltaX >= 300) deltaX = -deltaX;
                            if (deltaX == 3) deltaX = 4; else if (deltaX == 4) deltaX = 3; else if (deltaX == -3) deltaX = -4; else deltaX = -3;
                            if (posY + deltaY < 0 || posY + diameter + deltaY >= 300) deltaY = -deltaY;
                            for (int i = 0; i < diameter; i++)
                            {
                                Buffer.BlockCopy(backgroundMap.Pixels, 300 * (i + posY) * 4 + posX * 4, areaMap.Pixels, diameter * i * 4, diameter * 4);
                            }
                            lensTranslate.X = posX;
                            lensTranslate.Y = posY;
                            Buffer.BlockCopy(backgroundMap.Pixels, 0, aWriteableBitmap[4].Pixels, 0, 300 * 300 * 4);
                            aWriteableBitmap[4].Invalidate();
                            aWriteableBitmap[4].Render(drawEllipse, lensTranslate);
                            aWriteableBitmap[4].Invalidate();
                             
                        }
                        break;
                    }
                }
             }
            b4selected = currentSelected;
        }

        private void myTabControl_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            currentSelected = ((TabControl)sender).SelectedIndex;
            //if (currentSelected == 4) initPlasma();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            if (playButton.Content.Equals("Pause"))
            {
                playButton.Content = "Play";
                pause = true;
            }
            else
            {
                playButton.Content = "Pause";
                pause = false;
            }
        }

        private void myImage5_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            isPlasmaClicked = true;
        }

        private void myImage5_MouseLeftButtonUp(object sender, MouseButtonEventArgs e)
        {
            //if you clicked at the plasma image, a new one will be created
            if (isPlasmaClicked)
            {
                initPlasma();
                isPlasmaClicked = false;
            }
        }
    }
}
