﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Media.Effects;

namespace PerlinNoiseShader.Simplex2D
{
    public class Gi02GradShaderEffect:ShaderEffect
    {
        public static readonly DependencyProperty pArrayProperty = ShaderEffect.RegisterPixelShaderSamplerProperty("pArray", typeof(Gi02GradShaderEffect), 0);
        public static readonly DependencyProperty gi1GradArrayProperty = ShaderEffect.RegisterPixelShaderSamplerProperty("gi1GradArray", typeof(Gi02GradShaderEffect), 1);

        public Gi02GradShaderEffect()
        {
            Uri u = new Uri(@"/PerlinNoiseShader;component/Simplex2D/gi02Grad.ps", UriKind.Relative);
            PixelShader = new PixelShader() { UriSource = u };

            UpdateShaderValue(pArrayProperty);
            UpdateShaderValue(gi1GradArrayProperty);
        }
        public Brush pArray
        {
            get { return (Brush)GetValue(pArrayProperty); }
            set { SetValue(pArrayProperty, value); }
        }

        public Brush gi1GradArray
        {
            get { return (Brush)GetValue(gi1GradArrayProperty); }
            set { SetValue(gi1GradArrayProperty, value); }
        }
    }
}
